VERSION 5.00
Begin VB.Form FormStart 
   BorderStyle     =   1  'Fest Einfach
   Caption         =   "XML-Dateien auswerten"
   ClientHeight    =   4455
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5775
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4455
   ScaleWidth      =   5775
   StartUpPosition =   3  'Windows-Standard
   Begin VB.CommandButton Verarbeiten 
      Caption         =   "Verarbeiten..."
      Enabled         =   0   'False
      Height          =   375
      Left            =   3960
      TabIndex        =   10
      Top             =   3840
      Width           =   1575
   End
   Begin VB.CommandButton Validieren 
      Caption         =   "Validieren..."
      Enabled         =   0   'False
      Height          =   375
      Left            =   3960
      TabIndex        =   7
      Top             =   2400
      Width           =   1575
   End
   Begin VB.TextBox DTDDateiname 
      Enabled         =   0   'False
      Height          =   375
      Left            =   240
      TabIndex        =   6
      Top             =   2400
      Width           =   3495
   End
   Begin VB.CommandButton Einlesen 
      Caption         =   "Einlesen..."
      Height          =   375
      Left            =   3960
      TabIndex        =   1
      Top             =   960
      Width           =   1575
   End
   Begin VB.TextBox XMLDateiname 
      Height          =   375
      Left            =   240
      TabIndex        =   0
      Top             =   960
      Width           =   3495
   End
   Begin VB.Label Label6 
      Caption         =   "Die validierte Datei wird systematisch ausgelesen, und die Forms werden vorbereitet und dann angezeigt."
      Height          =   495
      Left            =   240
      TabIndex        =   9
      Top             =   3360
      Width           =   5295
   End
   Begin VB.Label Label5 
      Caption         =   "Schritt 3:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   -1  'True
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   240
      TabIndex        =   8
      Top             =   3120
      Width           =   735
   End
   Begin VB.Label Label4 
      Caption         =   "Die Datei wird validiert. So wird sichergestellt, dass beim spteren Verarbeiten keine Fehler auftauchen knnen."
      Height          =   495
      Left            =   240
      TabIndex        =   5
      Top             =   1920
      Width           =   5295
   End
   Begin VB.Label Label3 
      Caption         =   "Schritt 2:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   -1  'True
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   240
      TabIndex        =   4
      Top             =   1680
      Width           =   735
   End
   Begin VB.Label Label2 
      Caption         =   "Die unten angegebene Datei wird eingelesen. Dabei knnen bereits Fehler auftreten."
      Height          =   495
      Left            =   240
      TabIndex        =   3
      Top             =   480
      Width           =   5295
   End
   Begin VB.Label Label1 
      Caption         =   "Schritt 1:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   -1  'True
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   240
      TabIndex        =   2
      Top             =   240
      Width           =   735
   End
End
Attribute VB_Name = "FormStart"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.
'
'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source !

Option Explicit

Dim WithEvents Dokument As MSXML2.DOMDocument
Attribute Dokument.VB_VarHelpID = -1
Dim Fehler As MSXML2.IXMLDOMParseError

Private Sub Dokument_onreadystatechange()
    Select Case Dokument.readyState
    Case 1
        'Laden des Dokuments begonnen
        
    Case 2
        'Laden des Dokuments abgeschlossen
        
    Case 3
        'Datenstruktur liegt bereits Read-Only vor
        
    Case 4
        'Datenstruktur liegt komplett Read-Write vor bzw. Fehler
        '-> berprfung auf Fehler
        
        If Dokument.parseError.errorCode <> 0 Then
            MsgBox "Es gab einen Fehler beim Laden:" & vbCrLf & _
                Dokument.parseError.reason, vbCritical
            End
        Else
            Validieren.Enabled = True
        End If
    End Select
End Sub

Private Sub Einlesen_Click()
    'Schritt 1
    
    Dokument.Load XMLDateiname.Text
    XMLDateiname.Enabled = False
    Einlesen.Enabled = False
End Sub

Private Sub Form_Load()
    XMLDateiname = App.Path + "\Beispiel.xml"
    DTDDateiname = App.Path + "\xmlforms.dtd"
    Set Dokument = New MSXML2.DOMDocument
    Dokument.validateOnParse = False
End Sub

Private Sub Validieren_Click()
    'Schritt 2
    
    Validieren.Enabled = False
    Set Fehler = Dokument.Validate
    
    ' berprfung auf Fehler
    If Fehler.errorCode <> 0 Then
        MsgBox "Es gab einen Fehler beim Validieren:" & vbCrLf & _
            Fehler.reason, vbCritical
        End
    Else
        Verarbeiten.Enabled = True
    End If
End Sub

Private Sub Verarbeiten_Click()
    'Schritt 3
    
    Verarbeiten.Enabled = False
    
    'Hinweis zur Variablenbenennung:
    'Nodes haben Anfangsbuchstaben N, Attribute A
    Dim Nxmlforms As MSXML2.IXMLDOMNode
    Dim Nform As MSXML2.IXMLDOMNode
    Dim NformSubNode As MSXML2.IXMLDOMNode
    Dim Ncontrol As MSXML2.IXMLDOMNode
    Dim NcontrolSubNode As MSXML2.IXMLDOMNode
    Dim TempForm As FormMuster
    Dim TempControl As Control
    Dim ControlsZhler As Integer
    
    'Wurzel-Node abfragen
    Set Nxmlforms = Dokument.documentElement
    
    'Abfrage aller <form>-Nodes
    For Each Nform In Nxmlforms.childNodes
        
        'Erstellung eines neuen Formulars
        Set TempForm = New FormMuster
        
        'Sub-Nodes von <form> abfragen
        For Each NformSubNode In Nform.childNodes
            
            'Abfrage, ob es sich um <properties> oder
            '<controls> handelt
            Select Case NformSubNode.baseName
            Case "properties"
                'bergibt den Node sowie die aktuelle Form an
                EigenschaftenForm NformSubNode, TempForm
                
            Case "controls"
                
                'Abfrage aller <control>-Nodes
                For Each Ncontrol In NformSubNode.childNodes
                    Set TempControl = TempForm.Controls.Add _
                        (Ncontrol.Attributes(0).Text, "T" & ControlsZhler)
                    TempControl.Visible = True
                    ControlsZhler = ControlsZhler + 1
                    
                    'Sub-Nodes von <control> abfragen
                    For Each NcontrolSubNode In Ncontrol.childNodes
                        If NcontrolSubNode.baseName = "properties" Then
                            'bergibt den Node sowie das aktuelle Steuerelement an
                            EigenschaftenControl NcontrolSubNode, TempControl
                        End If
                    Next
                Next
            End Select
        Next
        TempForm.Show
    Next
End Sub

Sub EigenschaftenForm(Nproperties As MSXML2.IXMLDOMNode, F As FormMuster)
    Dim Nproperty As MSXML2.IXMLDOMNode
    Dim Aproperty As MSXML2.IXMLDOMAttribute
    Dim TempEigenschaft As String
    Dim TempEigenschaftWert As String
    
    'Abfrage aller <property>-Nodes
    For Each Nproperty In Nproperties.childNodes
        
        'Abfrage aller Attribute
        For Each Aproperty In Nproperty.Attributes
            
            'Abfrage, ob es sich um den Namen oder
            'den Wert der Eigenschaft handelt
            Select Case Aproperty.baseName
            Case "name"
                TempEigenschaft = Aproperty.Value
            Case "value"
                TempEigenschaftWert = Aproperty.Value
            End Select
        Next
        CallByName F, TempEigenschaft, VbLet, TempEigenschaftWert
    Next
End Sub

Sub EigenschaftenControl(Nproperties As MSXML2.IXMLDOMNode, C As Control)
    Dim Nproperty As MSXML2.IXMLDOMNode
    Dim Aproperty As MSXML2.IXMLDOMAttribute
    Dim TempEigenschaft As String
    Dim TempEigenschaftWert As String
    
    'Abfrage aller <property>-Nodes
    For Each Nproperty In Nproperties.childNodes
        
        'Abfrage aller Attribute
        For Each Aproperty In Nproperty.Attributes
        
            'Abfrage, ob es sich um den Namen oder
            'den Wert der Eigenschaft handelt
            Select Case Aproperty.baseName
            Case "name"
                TempEigenschaft = Aproperty.Value
            Case "value"
                TempEigenschaftWert = Aproperty.Value
            End Select
        Next
        
        CallByName C, TempEigenschaft, VbLet, TempEigenschaftWert
    Next
End Sub
